<?php
/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2005
sirfragalot@users.sourceforge.net

**********************************************************************************/
/*****
* BROWSECOMMON class
*
* Common methods for browsing as a 'tag cloud'
*
* 
$Header: /cvsroot/wikindx/wikindx3/core/browse/BROWSECOMMON.php,v 1.5 2005/12/20 07:36:22 sirfragalot Exp $
*****/
class BROWSECOMMON
{
// Constructor
	function BROWSECOMMON($db)
	{
		$this->db = $db;
		include_once("core/session/SESSION.php");
		$this->session = new SESSION();
	}
/**
* userBibCondition() - return a SQL condition clause if we are browsing a user bibliography to ensure that 
* listed, selected or searched resources come only from that user bibliography. If we are browsing the 
* master WIKINDX bibliography, return FALSE
*
* @return	SQL condition clause or FALSE
*/
	function userBibCondition($table)
	{
		$condition = $usingBib = FALSE;
		if($useBib = $this->session->getVar("mywikindx_bibliography_use"))
		{
			$recordset = $this->db->select(array('WKX_user_bibliography'), array('bibliography'), 
				" WHERE " . $this->db->formatfield('id') . "=" . $this->db->tidyInput($useBib));
			$dbBibs = $this->db->fetchOne($recordset);
			$bibsArray = explode(",", $dbBibs);
			foreach($bibsArray as $resourceId)
				$conditionArray[] = $this->db->tidyInput($resourceId);
			$condition = " ($table.id = " . implode(" OR $table.id = ", $conditionArray) . ")";
			$recordset = $this->db->select(array('WKX_user_bibliography'), array('title'), 
				" WHERE " . $this->db->formatfield('id') . "=" . $this->db->tidyInput($useBib));
			$row = $this->db->fetchRow($recordset);
			$usingBib = stripslashes($row['title']);
		}
		return array($condition, $usingBib);
	}
// Work out text colour (shade of red) based on field frequency.
// Arbitrarily limit the red range to 50 steps.  Anything overflowing this has an increased font size with the maximum red.
	function colourText($lowestSum, $highestSum, $frequency)
	{
		$g = $b = 0;
		if($frequency == $lowestSum)
			return array($frequency, "#000000");
		else if($frequency < 20)
			$red = floor(($frequency/19) * 255);
		else
			$red = 255;
		if($red < 16)
			$r = '0' . dechex($red);
		else
			$r = dechex($red);
		$g = floor($g + ($red/10));
		$b = floor($b + ($red/10));
		if($g < 16)
			$g = '0' . dechex($g);
		else
			$g = dechex($g);
		if($b < 16)
			$b = '0' . dechex($b);
		else
			$b = dechex($b);
		$colour = "#" . $r . $g . $b;
//print "$colour<BR>";
		return array($red + $frequency, $colour);
	}
// Work out text size based on field frequency.
// Size range is 1em to 1.5em for items with $index of <= 255 and more for anything larger.
// Limit maximum size to 2.5;
	function sizeText($lowestSum, $highestSum, $index)
	{
		if($index > 255)
			$size = 1 + round($index/400, 2);
		else
			$size = 1 + round($index/512, 2);
		if($size > 2.5)
			$size = 2.5;
		return $size . "em";
	}
}
?>