<?php
/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2005
sirfragalot@users.sourceforge.net
**********************************************************************************/
/**
* JS Format Bar class
* 
* @author	Mark Tsikanovski
* @editor	Mark Grimshaw
* @version	1
*/
class FORMATBAR
{
	function FORMATBAR()
	{
		include_once("core/html/FORM.php");
		include_once("core/html/MISC.php");
		include_once("core/html/TABLE.php");
		include_once("core/session/SESSION.php");
		$this->session = new SESSION();
		include_once("core/messages/UTF8.php");
		$this->utf8 = new UTF8();
	}
	function printFB($fileName = FALSE, $databaseID = FALSE)
	{
$pString = <<< END
<table id="formatBarStub" cellpadding="0" cellspacing="0" border="0">
  <tr>
    <td>
	  <input type="button" value="Display" class="formatButton" onFocus="blur()" name="display" title="Display Format Bar" onClick="displayFormatBar()" />
	</td>
  </tr>
</table>

<table id="formatBar" cellpadding="0" cellspacing="0" border="0">
  <tr>
    <td width="100%">
<!-- bold, italics, underline -->
	  <input type="button" value="B" style="font-weight: bold;" class="formatButton" onFocus="blur()" 
		name="bold" title="Bold" onClick="rteCommand('' + rte + '', 'bold', '')" />
	  <input type="button" value="I" style="font-weight: normal; font-style: italic;" 
			class="formatButton" onFocus="blur()" name="italic" title="Italic" 
			onClick="rteCommand('' + rte + '', 'italic', '')" />
	  <input type="button" value="U" style="font-weight: normal; text-decoration: underline;" 
		  class="formatButton" onFocus="blur()" name="underline" title="Underline" 
		  onClick="rteCommand('' + rte + '', 'underline', '')" />

<!-- font -->		  
	  <select class="formatSelect" name="font" title="Font" id="fontname_paperText" 
		onchange="setOption('' + rte + '', this.id, false)">
	    <option value="" selected="selected">Font</option>
	    <option style="font-family:'Arial';" value="Arial">Arial</option>
		<option style="font-family:'Courier';" value="Courier">Courier</option>
		<option style="font-family:'Georgia';" value="Georgia">Georgia</option>
		<option style="font-family:'Helvetica';" value="Helvetica">Helvetica</option>
		<option style="font-family:'MS Sans Serif';" value="MS Sans Serif">MS Sans Serif</option>
		<option style="font-family:'MS Serif';" value="MS Serif">MS Serif</option>
		<option style="font-family:'Palatino';" value="Palatino">Palatino</option>
		<option style="font-family:'Tahoma';" value="Tahoma">Tahoma</option>
		<option style="font-family:'Trebuchet MS';" value="Trebuchet MS">Trebuchet MS</option>
		<option style="font-family:'Times New Roman';" value="Times New Roman">Times New Roman</option>
		<option style="font-family:'Verdana';" value="Verdana">Verdana</option>
	  </select>

<!-- font size -- value matches HTML font size values -->
	  <select class="formatSelect" name="size" title="Size" id="fontsize_paperText" 
		onchange="setOption('' + rte + '', this.id, false)">
	    <option value="" selected="selected">Size</option>
	    <option style="font-size:8;" value="1">9</option>
		<option style="font-size:10;" value="2">11</option>
		<option style="font-size:12;" value="3">12</option>
		<option style="font-size:14;" value="4">16</option>
		<option style="font-size:16;" value="5">20</option>
		<option style="font-size:18;" value="6">28</option>
		<option style="font-size:20;" value="7">36</option>
	  </select>

<!-- font colour -->
	  <select class="formatSelect" name="color" title="Color" id="forecolor_paperText" 
		onChange="setOption('' + rte + '', this.id, false)">
	    <option value="" selected="selected">Color</option>
<!--	    <option style="color:black; background-color: white" value="#">#</option> -->
	    <option style="color:white; background-color: black" value="black">Black</option>
        <option style="color:white; background-color: silver" value="silver">Silver</option>
	    <option style="color:white; background-color: gray" value="gray">Gray</option>
        <option style="color:black; background-color: white" value="white">White</option>
	    <option style="color:white; background-color: maroon" value="maroon">Maroon</option>
        <option style="color:white; background-color: red" value="red">Red</option>
	    <option style="color:white; background-color: purple" value="purple">Purple</option>
        <option style="color:white; background-color: fuchsia" value="fuchsia">Fuchsia</option>
	    <option style="color:white; background-color: green" value="green">Green</option>
        <option style="color:white; background-color: lime" value="lime">Lime</option>
	    <option style="color:white; background-color: olive" value="olive">Olive</option>
        <option style="color:white; background-color: yellow" value="yellow">Yellow</option>
	    <option style="color:white; background-color: navy" value="navy">Navy</option>
        <option style="color:white; background-color: blue" value="blue">Blue</option>
	    <option style="color:white; background-color: teal" value="teal">Teal</option>
        <option style="color:white; background-color: aqua" value="aqua">Aqua</option>						
	  </select>

<!-- justify -->
	  <select  class="formatSelect" name="align" title="Align" id="justify_paperText" 
		onChange="setOption('' + rte + '', this.id, true)">
	    <option value="" selected="selected">Align</option>
	    <option value="justifyleft">Left</option>
		<option value="justifycenter">Center</option>
		<option value="justifyright">Right</option>
		<option value="justifyfull">Justify</option>
	  </select>

<!-- indent and outdent -->
	  <select class="formatSelectOptgroup" name="indent" title="Indent" id="indent_paperText" 
		onChange="setOption('' + rte + '', this.id, true)">
	    <option value="" selected="selected">Indent/Outdent</option>
		  <option value="indent">Indent Left</option>
		  <option value="outdent">Outdent Left</option>
		</optgroup>
	  </select>

<!-- subscript and superscript -->	  
	  	<button type="button" value="sub" class="formatButton" onFocus="blur()" 
			name="sub" title="Subscript" onClick="rteCommand('' + rte + '', 'subscript', '')">
			X<sub>2</sub></button> 	 
		<button type="button" value="sup" class="formatButton" onFocus="blur()" 
		name="sup" title="Superscript" onClick="rteCommand('' + rte + '', 'superscript', '')">
		X<sup>2</sup></button>

<!-- lists -->
		<select class="formatSelect" name="List" title="List" id="list_paperText" 
			onChange="setOption('' + rte + '', this.id, true)">
	    <option value="" selected="selected">List</option>
		<option value="insertunorderedlist">&bull;</option>
	    <option value="insertorderedlist">1...5</option>
<!-- think these are not possible with RTF export
		<option value="=aa">A...E</option>
		<option value="=a">a...e</option>
		<option value="=ii">I...V</option>
		<option value="=i">i...v</option>
-->
	  </select>
	  	  
<!-- URL -->
	  <input type="button" value="URL" class="formatButton" onFocus="blur()" name="url" title="Insert URL" 
		onClick="dlgInsertLink('' + rte + '', 'link', '')" />

<!-- image -->
	  <input type="button" value="Image" class="formatButton" onFocus="blur()" name="img" 
		title="Insert Image" onClick="addImage('' + rte + '')" /> 

<!-- table -->
	  <input type="button" value="Table" class="formatButton" onFocus="blur()" name="table" 
	  title="Insert Table" onClick="dlgInsertTable('' + rte + '', 'table', '')" />

<!-- special chars -->		
		<input type="button" value="&#936" class="formatButton" onFocus="blur()" name="spChar" 
		title="Insert Special Characters" id="spChar_paperText" onClick="dlgSpChar('' + rte + '', 'spChar', '')">
	  </td>
	<td style="text-align: right">
	  <input type="button" value="Hide" class="formatButton" onFocus="blur()" name="hide" title="Hide Format Bar" onClick="hideFormatBar()" />
	</td>	
	  </tr>
	  <tr>
	  <td>

<!-- cite tag -->
		<input type="button" value="Cite" class="formatButton" onFocus="blur()" name="cite" 
		title="Insert Cite Tags" 
		onClick="openCiteWindow('index.php?action=citeDisplay&amp;method=suwp')" />
		
<!-- insert metadata -->
	  <input type="button" value="Metadata" class="formatButton" onFocus="blur()" name="metadata" 
		title="Insert Metadata" 
		onClick="openMetadataWindow('index.php?action=suwpMetadataDisplay&amp;method=hdnpaperText')" />

<!-- various types of character manipulation and string insertion -->
<!--
	  <input type="button" value="a =&gt; A" class="formatButton" onFocus="blur()" id="upperCase" name="upperCase" title="Convert to Upper Case" onClick="upperCase('paperText')" />
      <input type="button" value="A =&gt; a" class="formatButton" onFocus="blur()" id="lowerCase" name="lowerCase" title="Convert to Lower Case" onClick="lowerCase('paperText')" />
-->
	  <input type="button" value="Timestamp" class="formatButton" onFocus="blur()" name="timestamp" 
	  title="Insert date/time stamp" onClick="timestamp()" />
	  <input type="button" value="Calendar" class="formatButton" onFocus="blur()" name="calendar" 
	  title="Look up and insert a valid date" onClick="calendar()" />		
	<input type="button" value="&Sigma;" class="formatButton" onFocus="blur()" name="stats" 
	title="Statistics" onClick="stats(rte)" />
	  <input type="button" value="UNDO" class="formatButton" onFocus="blur()" name="undo" title="Undo" onClick="rteCommand('' + rte + '', 'undo', '')" />
	  <input type="button" value="REDO" class="formatButton" onFocus="blur()" name="redo" title="Redo" onClick="rteCommand('' + rte + '', 'redo', '')" />
<!-- designMode command 'removeFormat' does not work in all cases so replace with bespoke function to remove all HTML tags. -->
<!-- remove design mode formatting -->
	  <input type="button" value="Remove Formatting" class="formatButton" onFocus="blur()" 
		name="Remove Formatting" title="Remove Formatting"
		onClick="rteCommand('' + rte + '', 'removeFormat', '')" />
<!--		onClick="removeFormat()" /> -->
	 
<!-- remove hyperlinks -->
	  <input type="button" value="Remove Hyperlink" class="formatButton" onFocus="blur()" 
		name="Remove Hyperlink" title="Remove Hyperlink" 
		onClick="rteCommand('' + rte + '', 'unLink', '')" />

	</td>
	<td>
	</td>
  </tr>
</table>
END;
//	$pString .= "<div id=\"pageContents\">";
	$pString .= FORM::formHeader("wpSave", "onsubmit=\"return updateRTE('paperText');\"");
	if($fileName)
		$pString .= FORM::hidden("fileName", $fileName);
	if($databaseID)
		$pString .= FORM::hidden("databaseID", $databaseID);
	$pString .= "<input type=\"hidden\" id=\"hdnpaperText\" name=\"hdnpaperText\" value=\"\">";
	$tmpString = base64_decode($this->session->getVar("wp_text"));

//safe code for preloading in the RTE
// Convert UTF-8
	$tmpString = $this->utf8->decodeUtf8($tmpString);
//convert all types of single quotes
	$tmpString = str_replace(chr(145), chr(39), $tmpString);
	$tmpString = str_replace(chr(146), chr(39), $tmpString);
	$tmpString = str_replace("'", "&#39;", $tmpString);
	
//convert all types of double quotes
	$tmpString = str_replace('"', "&#34;", $tmpString);
	$tmpString = str_replace(chr(147), chr(34), $tmpString);
	$tmpString = str_replace(chr(148), chr(34), $tmpString);
	
//strip carriage returns & line feeds
	$tmpString = str_replace(chr(10), " ", $tmpString);
	$text = str_replace(chr(13), " ", $tmpString);
//	$text = $tmpString;
	
	$title = base64_decode($this->session->getVar("wp_title"));

// Save/export options
	$pString .= MISC::p($this->messages->text("wp", "noAutosave"), "required", "center");
	$pString .= MISC::p(FORM::textInput($this->messages->text("wp", "paperTitle"), "title", $title, 50) 
		 . "&nbsp;&nbsp;" . FORM::formSubmit('Save'));
	include_once("core/styles/LOADSTYLE.php");
	$formats = array(
			'noExport' => $this->messages->text("wp", "noExport"),
			'rtf' => $this->messages->text("wp", "exportRtf"),
		);
	$pString .= TABLE::tableStart();
	$pString .= TABLE::trStart();
// Save or save and export
	if($format = $this->session->getVar("exportPaper_format"))
		$pString .= TABLE::td(FORM::selectedBoxValue($this->messages->text("wp", "export"), 
		"exportPaper_format", $formats, $format, 2));
	else
		$pString .= TABLE::td(FORM::selectedBoxValue($this->messages->text("wp", "export"), 
		"exportPaper_format", $formats, 'noExport', 2));
// Line spacing for paper body
	$spaces = array(
			'singleSpace' => $this->messages->text("wp", "singleSpace"),
			'oneHalfSpace' => $this->messages->text("wp", "oneHalfSpace"),
			'doubleSpace' => $this->messages->text("wp", "doubleSpace"),
		);
	if($space = $this->session->getVar("exportPaper_spacePaper"))
		$pString .= TABLE::td(FORM::selectedBoxValue($this->messages->text("wp", "lineSpacePaper"), 
		"exportPaper_spacePaper", $spaces, $space, 3), FALSE, FALSE, "bottom");
	else
		$pString .= TABLE::td(FORM::selectedBoxValue($this->messages->text("wp", "lineSpacePaper"), 
		"exportPaper_spacePaper", $spaces, 'singleSpace', 3), FALSE, FALSE, "bottom");
	$pString .= TABLE::td("&nbsp;");
	
	$pString .= TABLE::trEnd();
	$pString .= TABLE::trStart();
	
// bibliographic/citation export style
	$styles = LOADSTYLE::loadDir("styles/bibliography");
	if($style = $this->session->getVar("exportPaper_style"))
		$pString .= TABLE::td(FORM::selectedBoxValue($this->messages->text("config", "style"), 
		"exportPaper_style", $styles, $style, 4), FALSE, FALSE, "bottom");
	else
		$pString .= TABLE::td(FORM::selectedBoxValue($this->messages->text("config", "style"), 
		"exportPaper_style", $styles, $this->session->getVar("setup_style"), 4), FALSE, FALSE, "bottom");
// Line spacing for appended bibliography
	if($space = $this->session->getVar("exportPaper_spaceBib"))
		$pString .= TABLE::td(FORM::selectedBoxValue($this->messages->text("wp", "lineSpaceBib"), 
		"exportPaper_spaceBib", $spaces, $space, 3), FALSE, FALSE, "bottom");
	else
		$pString .= TABLE::td(FORM::selectedBoxValue($this->messages->text("wp", "lineSpaceBib"), 
		"exportPaper_spaceBib", $spaces, 'singleSpace', 3), FALSE, FALSE, "bottom");
// Indentation for appended bibliography
	$indents = array(
			'indentNone' => $this->messages->text("wp", "indentNone"),
			'indentAll' => $this->messages->text("wp", "indentAll"),
			'indentFL' => $this->messages->text("wp", "indentFL"),
			'indentNotFL' => $this->messages->text("wp", "indentNotFL"),
		);
	if($indent = $this->session->getVar("exportPaper_indentBib"))
		$pString .= TABLE::td(FORM::selectedBoxValue($this->messages->text("wp", "indentBib"), 
		"exportPaper_indentBib", $indents, $indent, 4), FALSE, FALSE, "bottom");
	else
		$pString .= TABLE::td(FORM::selectedBoxValue($this->messages->text("wp", "indentBib"), 
		"exportPaper_indentBib", $indents, 'indentNone', 4), FALSE, FALSE, "bottom");
	$pString .= TABLE::trEnd();
	
	$pString .= TABLE::trStart();
	$pString .= TABLE::td("&nbsp;");
// Line spacing for footnotes
	if($space = $this->session->getVar("exportPaper_spaceFt"))
		$pString .= TABLE::td(FORM::selectedBoxValue($this->messages->text("wp", "lineSpaceFt"), 
		"exportPaper_spaceFt", $spaces, $space, 3), FALSE, FALSE, "bottom");
	else
		$pString .= TABLE::td(FORM::selectedBoxValue($this->messages->text("wp", "lineSpaceFt"), 
		"exportPaper_spaceFt", $spaces, 'singleSpace', 3), FALSE, FALSE, "bottom");
// Indentation for footnotes
	$indents = array(
			'indentNone' => $this->messages->text("wp", "indentNone"),
			'indentAll' => $this->messages->text("wp", "indentAll"),
			'indentFL' => $this->messages->text("wp", "indentFL"),
			'indentNotFL' => $this->messages->text("wp", "indentNotFL"),
		);
	if($indent = $this->session->getVar("exportPaper_indentFt"))
		$pString .= TABLE::td(FORM::selectedBoxValue($this->messages->text("wp", "indentFt"), 
		"exportPaper_indentFt", $indents, $indent, 4), FALSE, FALSE, "bottom");
	else
		$pString .= TABLE::td(FORM::selectedBoxValue($this->messages->text("wp", "indentFt"), 
		"exportPaper_indentFt", $indents, 'indentNone', 4), FALSE, FALSE, "bottom");
	$pString .= TABLE::trEnd();

	$pString .= TABLE::tableEnd();
	$pString .= FORM::formEnd();
	if($databaseID)
		$pString .= MISC::p(MISC::a("link", $this->messages->text("wp", "revert"), 
			"index.php?action=wpRevertConfirm" . htmlentities("&databaseID=$databaseID")));
			
// iFrame for WYSIWYG editor
	$pString .= "<iframe class=\"suwpOuter\" id=\"paperText\" name=\"paperText\"  
		src=\"core/wp/JsFormatBar/blank.htm\" 
		onKeydown=\"getInputId(this, event)\" onFocus=\"getInputId(this, 'Focus')\"></iframe>";
// Load CSS file and pass to javascript
	$template = $this->session->getVar("setup_template");
	$template = "templates/$template/" . $template . ".css";
$pString .= <<< END
<script language="JavaScript" type="text/javascript">
<!--
enableDesignMode('paperText', "$text", "$template", false);
//-->
</script>
END;

//    $pString .= MISC::p("<textarea name=\"paperText\" id=\"paperText\" cols=\"100%\" rows=\"40\" 
//		onKeydown=\"getInputId(this, event)\" onFocus=\"getInputId(this, 'Focus')\">$text</textarea>", 
//		FALSE, "center");

//	$pString .= "</div>";
	return $pString;
	}
}
?>
