﻿<?php
/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

TheWIKINDX Team 2004
sirfragalot@users.sourceforge.net
**********************************************************************************/
/*****
* ERRORS_ptbr wikindx class - BRAZILIAN PORTUGUESE.
* NOTE TO TRANSLATORS:  1/  '###' appearing anywhere in an array value will be replaced by text supplied by the core WIKINDX code.
*				Do not remove it and do not put space around it.
*			2/  Do not change the key (the first part) of an array element.
*			3/  Ensure that each array element value is enclosed in double quotes "..." and is followed by a comma "...",
*			4/  Both the class name and the constructor name should be changed to match the (case-sensitive) name of 
*				the folder your language files are in.  For example, if you are supplying a Klingon translation and 
*				your languages/ folder is languages/kn/, the class and constructor name for the file SUCCESS.php 
*				must both be SUCCESS_kn.
*
*****/
class ERRORS_ptbr
{
// Constructor
	function ERRORS_ptbr()
	{
	}
// English errors
	function loadArrays()
	{
		return array(
// General database errors
			"dbError" => array(
				"open"		=>	"Incapaz de abrir o banco de dados.###",
				"write"		=>	"Incapaz de escrever no banco de dados.",
				"read"		=>	"Incapaz de ler no banco de dados.",
				"config"	=>	"Faltando Parâmetro de Configuração no arquivo config.php.",
				"populateTables"	=>	"Incapaz de popular o banco de dados com tabelas.",
				"fileOpen"	=>	"Incapaz de abrir o update/createMySQL.txt.",
				"updateMySQL"	=>	"Incapaz de atualizar o banco de dados com o update/updateMySQL.txt.",
				"dbSpecified"	=>	"Nenhum tipo RDBMS selecionado no config.php.",
			),
			"sessionError" => array(
				"write"		=>	"Incapas de ecrever na sessão.",
			),
// General user input errors
			"inputError" => array(
				"nan"		=>	"A entrada não é um número.###",
				"missing"	=>	"Faltando entrada.###",
				"invalid"	=>	"Entrada inválida.###",
				"userExists"	=>	"O nome do usuário já existe",
				"mail"		=>	"Incapaz de enviar emails a você - favor contactar o administrador do WIKINDX",
// User registration - the hashKey supplied by email to a user has been deleted from the database as they did not 
// confirm their registration within 10 days.
				"noHashKey"	=>	"Aquela chave não existe mais. Favor registre novamente",
				"styleExists"	=>	"Aquele estilo já existe",
			),
// File operations (import/export)
			"file"	=> array(
				'write'			=>	"Incapaz de escrever no arquivo###",
				'noSql'			=>	"Você precisa primeiro listar ou selecionar os recursos",
				"read"			=>	"Incapaz de ler o diretório ou arquivo###",
				"empty"			=>	"Você ainda não exportou nenhum arquivo",
				"upload"		=>	"Erro ao enviar arquivo",
				"folder"		=>	"Incapaz de criar o diretório",
//				"bibtexMap"		=>	"You may not map more than one BibTeX field to the same 
//								WIKINDX field",
			),
// Following input, editing operations etc., these messages are printed when a user attempts to redo the operation (usually 
// by clicking on browser's 'reload' button)
			"done" => array(
				"resource" =>	"Você já criou/editou/removeu aquele recurso",
				"note" =>	"Você já criou/editou/removeu aquela nota",
				"quote" =>	"Você já criou/editou/removeu aquela citação",
				"paraphrase" =>	"Você já criou/editou/removeu aquela paráfrase",
				"musing" =>	"Você já criou/editou/removeu aquela reflexão",
				"abstract" =>	"Você já criou/editou/removeu aquele sumário",
				"creator" =>	"Você já criou/editou/removeu aquele criador",
				"publisher" =>	"Você já criou/editou/removeu aquele editor",
				"collection" =>	"Você já criou/editou/removeu aquela coleção",
				"fileImport" =>	"Você já importou aquele arquivo",
				"keyword"	=>	"Você já editou aquela palavra chave",
				"register"	=>	"Você já registrou",
				"bibliography" =>	"Você já criou/editou/removeu aquela bibliografia",
				"custom" =>	"Você já editou/removeu aquele campo customizado",
				"attachAdd"	=>	"Você já anexou aquele arquivo",
				"attachDelete"	=>	"Você já removeu aqueles arquivos",
				"wp"	=>	"Você já removeu aquele ensaio",
			),
			"warning" => array(
// When inputting a new resource
				"resourceExists" => "Ao menos um recurso do tipo com este título já existe",
// WIKINDX not in multi user mode - this is displayed at the logon screen
				"superadminOnly" => "Multi usuário não tem estado abilitado - apenas o superadmin pode autenticar-se",
// When editing a creator, the new one may be the same as an existing one.
				"creatorExists"	=>	"Um criador com aquele nome já existe no banco de dados",
// When editing a publisher, the new one may be the same as an existing one.
				"publisherExists"	=>	"Um editor com aquele nome e localização já existe no banco de dados",
// When editing a collection, the new one may be the same as an existing one.
				"collectionExists"	=>	"Uma coleção com aquele nome já existe no banco de dados",
// When editing a keyword, the new one may be the same as an existing one.
				"keywordExists"	=>	"Uma palavra chave com aquele nome já existe no banco de dados",
// When importing a paper into the word processor
				"paperExists"	=>	"Aquele ensaio já existe",
// When WIKINDX detects what is probably an incompatible browser for the SUWP, issue this warning.
				"suwpBrowserWarning"	=>	"Seu navegador provavelmente não irá funcionar com o SUWP como
ele não parece ter um modo de design HTML. É sabido que o WIKINDX SUWP funciona bem com o Mozilla, Firefox, Netscape 8 e Internet Explorer 6",
			),
		);
	}
}
?>
